"use strict";
(self["webpackChunkpy_ssv"] = self["webpackChunkpy_ssv"] || []).push([["lib_index_js"],{

/***/ "./lib/index.js":
/*!**********************!*\
  !*** ./lib/index.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   MODULE_NAME: () => (/* reexport safe */ _version__WEBPACK_IMPORTED_MODULE_0__.MODULE_NAME),
/* harmony export */   MODULE_VERSION: () => (/* reexport safe */ _version__WEBPACK_IMPORTED_MODULE_0__.MODULE_VERSION),
/* harmony export */   SSVRenderModel: () => (/* reexport safe */ _widget__WEBPACK_IMPORTED_MODULE_1__.SSVRenderModel),
/* harmony export */   SSVRenderView: () => (/* reexport safe */ _widget__WEBPACK_IMPORTED_MODULE_1__.SSVRenderView)
/* harmony export */ });
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./version */ "./lib/version.js");
/* harmony import */ var _widget__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./widget */ "./lib/widget.js");
/*
 * Copyright (c) 2023 Thomas Mathieson.
 * Distributed under the terms of the MIT license.
 */




/***/ }),

/***/ "./lib/version.js":
/*!************************!*\
  !*** ./lib/version.js ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   MODULE_NAME: () => (/* binding */ MODULE_NAME),
/* harmony export */   MODULE_VERSION: () => (/* binding */ MODULE_VERSION)
/* harmony export */ });
/*
 * Copyright (c) 2023 Thomas Mathieson.
 * Distributed under the terms of the MIT license.
 */
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore
// eslint-disable-next-line @typescript-eslint/no-var-requires
const data = __webpack_require__(/*! ../package.json */ "./package.json");
/**
 * The _model_module_version/_view_module_version this package implements.
 *
 * The html widget manager assumes that this is the same as the npm package
 * version number.
 */
const MODULE_VERSION = data.version;
/*
 * The current package name.
 */
const MODULE_NAME = data.name;


/***/ }),

/***/ "./lib/widget.js":
/*!***********************!*\
  !*** ./lib/widget.js ***!
  \***********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SSVRenderModel: () => (/* binding */ SSVRenderModel),
/* harmony export */   SSVRenderView: () => (/* binding */ SSVRenderView)
/* harmony export */ });
/* harmony import */ var _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyter-widgets/base */ "webpack/sharing/consume/default/@jupyter-widgets/base");
/* harmony import */ var _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _version__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./version */ "./lib/version.js");
/* harmony import */ var _css_widget_css__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../css/widget.css */ "./css/widget.css");
/*
 * Copyright (c) 2023 Thomas Mathieson.
 * Distributed under the terms of the MIT license.
 */


// Import the CSS

var StreamingMode;
(function (StreamingMode) {
    StreamingMode["PNG"] = "png";
    StreamingMode["JPG"] = "jpg";
    StreamingMode["H264"] = "h264";
})(StreamingMode || (StreamingMode = {}));
class SSVRenderModel extends _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_0__.DOMWidgetModel {
    defaults() {
        return {
            ...super.defaults(),
            _model_name: SSVRenderModel.model_name,
            _model_module: SSVRenderModel.model_module,
            _model_module_version: SSVRenderModel.model_module_version,
            _view_name: SSVRenderModel.view_name,
            _view_module: SSVRenderModel.view_module,
            _view_module_version: SSVRenderModel.view_module_version,
            streaming_mode: StreamingMode.PNG,
            stream_data: "ts",
            mouse_pos_x: 0,
            mouse_pos_y: 0
        };
    }
}
SSVRenderModel.serializers = {
    ..._jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_0__.DOMWidgetModel.serializers
    // Add any extra serializers here
};
SSVRenderModel.model_name = "SSVRenderModel";
SSVRenderModel.model_module = _version__WEBPACK_IMPORTED_MODULE_1__.MODULE_NAME;
SSVRenderModel.model_module_version = _version__WEBPACK_IMPORTED_MODULE_1__.MODULE_VERSION;
SSVRenderModel.view_name = "SSVRenderView"; // Set to null if no view
SSVRenderModel.view_module = _version__WEBPACK_IMPORTED_MODULE_1__.MODULE_NAME; // Set to null if no view
SSVRenderModel.view_module_version = _version__WEBPACK_IMPORTED_MODULE_1__.MODULE_VERSION;
class SSVRenderView extends _jupyter_widgets_base__WEBPACK_IMPORTED_MODULE_0__.DOMWidgetView {
    constructor() {
        super(...arguments);
        this._stream_img_element = null;
    }
    initialize(parameters) {
        super.initialize(parameters);
    }
    render() {
        this.el.classList.add("ssv-render-widget");
        switch (this.model.get("streaming_mode")) {
            case StreamingMode.JPG:
            case StreamingMode.PNG:
                this._stream_img_element = document.createElement("img");
                this.el.appendChild(this._stream_img_element);
                break;
            default:
                console.error(`Unsupported streaming mode '${this.model.get("streaming_mode")}'!`);
        }
        this.stream_data_changed();
        this.model.on("change:stream_data", this.stream_data_changed, this);
        if (this._stream_img_element) {
            setInterval(() => {
                this.send({ "heartbeat": 0 });
            }, 500);
            //let mousePos = { x: 0, y: 0 };
            this._stream_img_element.addEventListener("mousemove", (event) => {
                /*mousePos = {
                  x: event.clientX,// / target.width,
                  y: event.clientY,// / target.height
                };*/
                if ((event === null || event === void 0 ? void 0 : event.target) == null || !(event.target instanceof HTMLElement))
                    return;
                const rect = event.target.getBoundingClientRect();
                this.model.set("mouse_pos_x", Math.round(event.clientX - rect.left));
                this.model.set("mouse_pos_y", Math.round(rect.height - (event.clientY - rect.top)));
                this.model.save_changes();
            });
        }
    }
    stream_data_changed() {
        if (!this._stream_img_element)
            return;
        //this.el.textContent = this.model.get('stream_data');
        this._stream_img_element.src = this.model.get("stream_data");
    }
}


/***/ }),

/***/ "./package.json":
/*!**********************!*\
  !*** ./package.json ***!
  \**********************/
/***/ ((module) => {

module.exports = JSON.parse('{"name":"py-ssv","version":"0.3.1","description":"Leverage the power of shaders for scientific visualisation in Jupyter","keywords":["jupyter","jupyterlab","jupyterlab-extension","widgets","glsl","shaders","opengl"],"files":["lib/**/*.js","dist/*.js","css/*.css"],"homepage":"https://github.com/space928/Shaders-For-Scientific-Visualisation","bugs":{"url":"https://github.com/space928/Shaders-For-Scientific-Visualisation/issues"},"license":"MIT","author":{"name":"Thomas Mathieson","email":"thomas@mathieson.dev"},"main":"lib/index.js","types":"./lib/index.d.ts","repository":{"type":"git","url":"https://github.com/space928/Shaders-For-Scientific-Visualisation.git"},"scripts":{"build":"jlpm build:lib && jlpm build:labextension:dev && yarn run build:nbextension","build:labextension":"jupyter labextension build .","build:labextension:dev":"jupyter labextension build --development True .","build:lib":"tsc --sourceMap","build:lib:prod":"tsc","build:nbextension":"webpack","build:prod":"jlpm clean && jlpm build:lib:prod && jlpm build:labextension && yarn run build:nbextension","clean":"jlpm clean:lib","clean:all":"jlpm clean:lib && jlpm clean:labextension && jlpm clean:lintcache && jlpm clean:nbextension","clean:labextension":"rimraf pySSV/labextension pySSV/_version.py","clean:lib":"rimraf lib tsconfig.tsbuildinfo","clean:lintcache":"rimraf .eslintcache .stylelintcache","clean:nbextension":"rimraf pySSV/nbextension/static/index.js","eslint":"jlpm eslint:check --fix","eslint:check":"eslint . --cache --ext .ts,.tsx","install:extension":"jlpm build","lint":"jlpm stylelint && jlpm prettier && jlpm eslint","lint:check":"jlpm stylelint:check && jlpm prettier:check && jlpm eslint:check","prepack":"yarn run build:lib","prettier":"jlpm prettier:base --write --list-different","prettier:base":"prettier \\"**/*{.ts,.tsx,.js,.jsx,.css,.json,.md}\\"","prettier:check":"jlpm prettier:base --check","stylelint":"jlpm stylelint:check --fix","stylelint:check":"stylelint --cache \\"css/**/*.css\\"","test":"jest --coverage","watch":"run-p watch:src watch:labextension","watch:labextension":"jupyter labextension watch .","watch:lib":"tsc -w","watch:nbextension":"webpack --watch --mode=development","watch:src":"tsc -w --sourceMap"},"dependencies":{"@jupyter-widgets/base":"^1.1.10 || ^2 || ^3 || ^4 || ^5 || ^6"},"devDependencies":{"@babel/core":"^7.5.0","@babel/preset-env":"^7.5.0","@jupyter-widgets/base-manager":"^1.0.2","@jupyterlab/builder":"^4.0.0","@jupyterlab/testutils":"^4.0.0","@lumino/application":"^2.0.1","@lumino/widgets":"^2.0.1","@types/jest":"^29.2.0","@types/json-schema":"^7.0.11","@types/react":"^18.0.26","@types/react-addons-linked-state-mixin":"^0.14.22","@types/webpack-env":"^1.13.6","@typescript-eslint/eslint-plugin":"^6.1.0","@typescript-eslint/parser":"^6.1.0","acorn":"^7.2.0","css-loader":"^6.7.1","eslint":"^8.36.0","eslint-config-prettier":"^8.8.0","eslint-plugin-prettier":"^5.0.0","fs-extra":"^7.0.0","identity-obj-proxy":"^3.0.0","jest":"^29.2.0","mkdirp":"^0.5.1","npm-run-all":"^4.1.5","prettier":"^3.0.0","rimraf":"^5.0.1","source-map-loader":"^1.0.2","style-loader":"^3.3.1","stylelint":"^15.10.1","stylelint-config-recommended":"^13.0.0","stylelint-config-standard":"^34.0.0","stylelint-csstree-validator":"^3.0.0","stylelint-prettier":"^4.0.0","ts-jest":"^29.0.0","ts-loader":"^8.0.0","typescript":"~5.2.2","webpack":"^5.61.0","webpack-cli":"^4.0.0","yjs":"^13.5.40"},"jupyterlab":{"extension":"lib/plugin","outputDir":"pySSV/labextension","sharedPackages":{"@jupyter-widgets/base":{"bundled":false,"singleton":true}}},"eslintConfig":{"extends":["eslint:recommended","plugin:@typescript-eslint/eslint-recommended","plugin:@typescript-eslint/recommended","plugin:prettier/recommended"],"parser":"@typescript-eslint/parser","parserOptions":{"project":"tsconfig.json","sourceType":"module"},"plugins":["@typescript-eslint"],"rules":{"@typescript-eslint/naming-convention":["error",{"selector":"interface","format":["PascalCase"],"custom":{"regex":"^I[A-Z]","match":true}}],"@typescript-eslint/no-unused-vars":["warn",{"args":"none"}],"@typescript-eslint/no-explicit-any":"off","@typescript-eslint/no-namespace":"off","@typescript-eslint/no-use-before-define":"off","@typescript-eslint/quotes":["warn","double",{"avoidEscape":true,"allowTemplateLiterals":false}],"curly":["error","multi-or-nest","consistent"],"eqeqeq":"error","prefer-arrow-callback":"error","function-call-argument-newline":["warn","consistent"],"function-paren-newline":"off"}},"eslintIgnore":["node_modules","dist","coverage","**/*.d.ts","tests","**/__tests__","ui-tests"],"prettier":{"singleQuote":false,"trailingComma":"none","arrowParens":"avoid","endOfLine":"auto","overrides":[{"files":"package.json","options":{"tabWidth":4}}]},"stylelint":{"extends":["stylelint-config-recommended","stylelint-config-standard","stylelint-prettier/recommended"],"plugins":["stylelint-csstree-validator"],"rules":{"csstree/validator":true,"property-no-vendor-prefix":null,"selector-no-vendor-prefix":null,"value-no-vendor-prefix":null}},"styleModule":"css/index.js"}');

/***/ })

}]);
//# sourceMappingURL=lib_index_js.0b907727467e25633749.js.map